diff --git a/lfs/rtl8821cu b/lfs/rtl8821cu
new file mode 100644
index 000000000..b5a0357bc
--- /dev/null
+++ b/lfs/rtl8821cu
@@ -0,0 +1,95 @@
+###############################################################################
+#                                                                             #
+# IPFire.org - A linux based firewall                                         #
+# Copyright (C) 2007-2022  IPFire Team <info@ipfire.org>                      #
+#                                                                             #
+# This program is free software: you can redistribute it and/or modify        #
+# it under the terms of the GNU General Public License as published by        #
+# the Free Software Foundation, either version 3 of the License, or           #
+# (at your option) any later version.                                         #
+#                                                                             #
+# This program is distributed in the hope that it will be useful,             #
+# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
+# GNU General Public License for more details.                                #
+#                                                                             #
+# You should have received a copy of the GNU General Public License           #
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.       #
+#                                                                             #
+###############################################################################
+
+###############################################################################
+# Definitions
+###############################################################################
+
+include Config
+
+VERSUFIX = ipfire$(KCFG)
+MODPATH = /lib/modules/$(KVER)-$(VERSUFIX)/extra/wlan
+
+VER        = 20210118-f91ddf3cc7555b9a1c27c90f23764cfc0b1b6f9c
+
+THISAPP    = 8821cu-$(VER)
+DL_FILE    = $(THISAPP).tar.gz
+DL_FROM    = $(URL_IPFIRE)
+DIR_APP    = $(DIR_SRC)/$(THISAPP)
+TARGET     = $(DIR_INFO)/$(THISAPP)-kmod-$(KVER)-$(VERSUFIX)
+
+###############################################################################
+# Top-level Rules
+###############################################################################
+
+objects = $(DL_FILE)
+
+$(DL_FILE) = $(DL_FROM)/$(DL_FILE)
+
+$(DL_FILE)_BLAKE2 = a3ea84b45258fed06baab211393725391fe26686fe85c2273605e6cb59e3e83e54d45e24bc2c3b046de9bb3af8a8cc3a584dbd80ecea3bb8416fb5e79113fb69
+
+install : $(TARGET)
+
+check : $(patsubst %,$(DIR_CHK)/%,$(objects))
+
+download :$(patsubst %,$(DIR_DL)/%,$(objects))
+
+b2 : $(subst %,%_BLAKE2,$(objects))
+
+dist:
+	$(PAK)
+
+###############################################################################
+# Downloading, checking, b2sum
+###############################################################################
+
+$(patsubst %,$(DIR_CHK)/%,$(objects)) :
+	@$(CHECK)
+
+$(patsubst %,$(DIR_DL)/%,$(objects)) :
+	@$(LOAD)
+
+$(subst %,%_BLAKE2,$(objects)) :
+	@$(B2SUM)
+
+###############################################################################
+# Installation Details
+###############################################################################
+
+$(TARGET) : $(patsubst %,$(DIR_DL)/%,$(objects))
+	@$(PREBUILD)
+	@rm -rf $(DIR_APP) && cd $(DIR_SRC) && tar axf $(DIR_DL)/$(DL_FILE)
+	cd $(DIR_APP) && CONFIG_RTL8821CU=m make $(MAKETUNING) \
+		-C /lib/modules/$(KVER)-$(VERSUFIX)/build/ M=$(DIR_APP)/ modules
+
+	# Install the built kernel modules.
+	mkdir -p $(MODPATH)
+	cd $(DIR_APP) && for f in $$(ls *.ko); do \
+		/lib/modules/$$(uname -r)$(KCFG)/build/scripts/sign-file sha512 \
+			/lib/modules/$$(uname -r)$(KCFG)/build/certs/signing_key.pem \
+			/lib/modules/$$(uname -r)$(KCFG)/build/certs/signing_key.x509 \
+			$$f; \
+		xz $$f; \
+		install -m 644 $$f.xz $(MODPATH); \
+	done
+
+	@rm -rf $(DIR_APP)
+	@$(POSTBUILD)
+
diff --git a/make.sh b/make.sh
index 7fb63b913..e70dacd2a 100755
--- a/make.sh
+++ b/make.sh
@@ -1172,6 +1172,7 @@ buildipfire() {
   lfsmake2 rtl8189fs		KCFG=""
   lfsmake2 rtl8812au		KCFG=""
   lfsmake2 rtl8822bu		KCFG=""
+  lfsmake2 rtl8821cu		KCFG=""
   lfsmake2 xradio		KCFG=""
   lfsmake2 linux-initrd		KCFG=""
 